Imports WINDREAMLib
Imports WINDREAMLib.WMCOMEvent
Imports WINDREAMLib.WMEntity
Imports WMOSRCHLib
Imports DigitalData.Modules.Logging
Imports EmailProfiler.Common.ClassCurrent

Public Class clsWindream_allgemein

#Region "+++++ Konstanten +++++"
    Const DEBUG = AUS
    Const AUS = 0
    Const WINDREAM = 1
    Const VARIABLEN = 2
#End Region

#Region "+++++ Variablen +++++"
    Public Shared oConnect ' der Typ darf nicht festgelegt werden (warum auch immer... geht sonst nicht)
    Public Shared oWMSession 'As WINDREAMLib.WMSession ' der Typ darf nicht festgelegt werden (warum auch immer... geht sonst nicht)
    Public Shared oBrowser As New WMOBRWSLib.ServerBrowser
    Public Shared oDokumentTypen As WINDREAMLib.WMObjects
    Private Shared oController As New WMOSearchController
    Private Shared Logger As Logger
#End Region


#Region "+++++ Allgemeine Methoden und Funktionen +++++"

    ''' <summary>
    ''' Konstruktor für die windream-Klasse
    ''' </summary>
    ''' <remarks></remarks>
    Sub New(LogConf As LogConfig)
        Logger = LogConf.GetLogger
        ' wenn ein Fehler bei der Initialisierung auftrat
        If Not Init() Then
            ' Nachricht ausgeben
            Logger.Warn("Es trat ein Fehler bei der Initialisierung der Klasse windream auf. Bitte prüfen Sie ob der windream-Server aktiv ist und alle Dienste gestartet sind")
            ' das Programm "abschießen"
            Process.GetCurrentProcess.Kill()
        End If
    End Sub


    ''' <summary>
    ''' Initialisiert die statische Klasse (Login, Session starten, usw.)
    ''' </summary>
    ''' <returns>Liefert True wenn das Anmelden erfolgreich war, sonst False</returns>
    ''' <remarks></remarks>
    Public Function Init() As Boolean

        Try
            Try
                Dim oHourDifference As Integer
                oHourDifference = CInt(DateDiff(DateInterval.Hour, CURRENToWMSession_Created, Now))


                If IsNothing(CURRENToWMSession) Or oHourDifference >= 2 Then
                    ' Session-Objekt instanziieren und mit dem im Client ausgewählten Server belegen
                    oWMSession = CreateObject("Windream.WMSession", GetCurrentServer)
                    ' Connection-Objekt instanziieren
                    oConnect = CreateObject("Windream.WMConnect")
                    CURRENToWMConnect = oConnect
                Else
                    Logger.Debug("WMSession already created!")
                    oWMSession = CURRENToWMSession
                    Return True
                End If

            Catch ex As Exception
                Return False
            End Try

            ' wenn windream nicht angemeldet ist
            If Not IsLoggedIn() Then
                ' Art der Anmeldung an windream festlegen
                '   0x0L (also 0)                   = Standard windream Benutzer
                '  WM_MODULE_ID_DOCTYPEEDITOR_LIC  = ermöglicht Zugriff auf die windream Management Funktionen (Z.B. zur Verwaltung der windream Dokumententypen, Auswahllisten, etc.)
                '  WM_MODULE_ID_INDEXSERVICE       = ermöglicht der Session die Indexierungs-Events vom windream DMS-Service zu empfangen
                oConnect.ModuleID = 0

                ' setzt die minimal erwartete windream-Version 
                oConnect.MinReqVersion = "3"
                ' Logger.Debug("Personifizierung'")

                ' -- Impersonifizierung nur möglich mit registry-eintrag --
                'oConnect.UserName = "\digitaldata\SchreiberM"
                'oConnect.Password = "pw"

                ' Verbindung mit Session-Objekt (und dem ausgewählten Server) aufbauen
                oConnect.LoginSession(oWMSession)
                Logger.Debug("windream-Server: '" & GetCurrentServer() & "'")
                Logger.Debug("windream-UserName: '" & oConnect.UserName & "'")

                If oWMSession.aLoggedin = False Then
                    Logger.Warn("Es konnte keine Verbindung mit dem windream-Server hergestellt werden")
                    Return False
                End If

                ' AUSGABE VON SYSTEMINFORMATIONEN
                ' Gibt die Versionsart (Lizenztyp) also Small-Business-Edition (SBE), Small-Business-Extension (SBX) 
                ' oder Business-Edition (BE) aus
                'MsgBox("WindreamVersion: " & oSession.GetSystemInfo("WindreamVersion") & vbNewLine & "LicenceKey: " & oSession.GetSystemInfo("LicenceKey") & vbNewLine & _
                '       vbNewLine & "LicenceName: " & oSession.GetSystemInfo("LicenceName"))

                'Dim WMCtrl As AISCONTROLDATACOMLib.AISControlData
                'WMCtrl = New AISCONTROLDATACOMLib.AISControlData

                '' liefert die Versionsnummer des Clients
                'MsgBox(WMCtrl.WMWorkstationBuildNo)
                'MsgBox(WMCtrl.W
                '' liefert den Servernamen des angemeldeten windreams
                'MsgBox(WMCtrl.WMServerName)

                Try
                    oWMSession.SwitchEvents(WMCOMEventWMSessionNeedIndex, False)
                    ' der Parameter WMEntityDocument definiert, dass nur Dokumenttypen und keine 
                    ' Ordnertypen ausgelesen werden
                    oDokumentTypen = oWMSession.GetWMObjectTypes(WINDREAMLib.WMEntity.WMEntityDocument)
                Catch ex As Exception
                    Logger.Error(ex)
                    Return False
                End Try
            End If
            CURRENToWMSession = oWMSession
            CURRENToWMSession_Created = Now
            Logger.Debug("Alles OK - Erfolgreich angemeldet und Session aufgebaut")
            Return True

        Catch ex As Exception
            Logger.Error(ex)

            Return False
        End Try

    End Function

#End Region



#Region "+++++ Funktionen die für den Objekttyp relevate Informationen zurückliefern +++++"

    ''' <summary>
    ''' Liefert alle Objekttypen des aktuellen Servers als windream-Objekte.
    ''' </summary>
    ''' <returns>Alle Objekttypen als WMObjects-Objekt</returns>
    ''' <remarks></remarks>
    Public Function GetObjecttypesAsObjects() As WMObjects
        Try

            Return oDokumentTypen

        Catch ex As Exception
            Logger.Error(ex)
            'clsLogger.AddError("Fehler beim Auslesen der Objekttypen: " & ex.Message, "clswindream.GetObjecttypesAsObjects")
            Return Nothing
        End Try
    End Function

    ''' <summary>
    ''' Liefert alle Objekttypen des aktuellen Servers als Array aus Strings.
    ''' </summary>
    ''' <returns>Array mit allen Objekttypen als Strings</returns>
    ''' <remarks></remarks>
    Public Function GetObjecttypesAsStrings() As String()
        Dim objektTypenStr() As String
        Try
            Dim ocount As Integer = 0

            For i As Integer = 0 To oDokumentTypen.Count
                Dim obj = oDokumentTypen.Item(i).aName
                If obj.ToString <> "Annotation" Then
                    ReDim Preserve objektTypenStr(ocount)
                    objektTypenStr(ocount) = obj.ToString
                    ocount += 1
                End If

            Next

            Return objektTypenStr

        Catch ex As Exception
            Return objektTypenStr
        End Try

    End Function

    ''' <summary>
    ''' Liefert alle Indexe eines Objekttypen.
    ''' </summary>
    ''' <param name="name">Name des Objekttyps</param>
    ''' <returns>Array mit allen Objekttyp zugeordneten Indexen als String</returns>
    ''' <remarks></remarks>
    Public Function GetIndicesByObjecttype(ByVal name As String) As String()
        Try
            Dim oObjectType As WMObject
            Dim oIndexAttributes As WMObjectRelation
            Dim oIndexAttribute As WMObject
            Dim oIndex As WMObject
            Dim oRelProperties As WMObjectRelationClass

            ' den Objekttyp laden
            oObjectType = oWMSession.GetWMObjectByName(WMEntityObjectType, name)

            ' Beziehung zu Indizes des Objekttyp auslesen
            oIndexAttributes = oObjectType.GetWMObjectRelationByName("TypeAttributes")

            ' Array für Indizes vorbereiten
            Dim aIndexNames(oIndexAttributes.Count - 1) As String

            ' alle Indizes durchlaufen
            For j As Integer = 0 To oIndexAttributes.Count - 1

                ' aktuellen Index auslesen
                oIndexAttribute = oIndexAttributes.Item(j)

                ' Eigenschaften des Index auslesen
                oRelProperties = oIndexAttribute.GetWMObjectRelationByName("Attribute")

                ' Index aus den Eigenschaften auslesen
                oIndex = oRelProperties.Item(0)

                ' Indexname speichern
                aIndexNames(j) = oIndex.aName
            Next

            ' Indexarray zurückgeben
            Return aIndexNames

        Catch ex As Exception
            Logger.Error(ex)
            Return Nothing
        End Try
    End Function
    ''' <summary>
    ''' Liefert einen Objekttyp als WMObject an Hand dessen Name.
    ''' </summary>
    ''' <param name="objekttypName">Name des Objekttyps</param>
    ''' <returns>Objekttyp als WMObject</returns>
    ''' <remarks></remarks>
    Public Function GetObjecttypeByName(ByVal objekttypName As String) As WMObject
        Try
            ' alle Objekttypen auslesen
            Dim oObjectTypes As WMObjects = oWMSession.GetWMObjectTypes(WINDREAMLib.WMEntity.WMEntityDocument)

            ' alle Objekttypen durchlaufen und nach dem mit dem angegebenen Namen suchen
            For Each oObjectType As WMObject In oObjectTypes
                If oObjectType.aName = objekttypName Then
                    Return oObjectType
                End If
            Next

            Return Nothing

        Catch ex As Exception
            Logger.Error(ex)

            Return Nothing
        End Try
    End Function

    ''' <summary>
    ''' Überprüft ob der angegebene Index im Objekttyp existiert
    ''' </summary>
    ''' <param name="objekttyp">Name des zu durchsuchenden Objekttyps</param>
    ''' <param name="indexname">Name des zu suchenden Indexes</param>
    ''' <returns>Liefert True wenn der Index im Objekttyp existiert, sonst False</returns>
    ''' <remarks></remarks>
    Public Function ExistIndexInObjekttyp(ByVal objekttyp As String, ByVal indexname As String) As Boolean
        Try
            Dim indexnamen() As String = GetIndicesByObjecttype(objekttyp)

            If indexnamen Is Nothing Then Return False

            For Each index As String In indexnamen
                If index = indexname Then Return True
            Next

        Catch ex As Exception
            Logger.Error(ex)
        End Try

        Return False
    End Function

#End Region

#Region "+++++ Allgemeine Funktionen die Informationen zurückliefern +++++"

    ''' <summary>
    ''' Liefert True wenn die windream-Session angemeldet ist und False für den Fall, dass die Session nicht eingeloggt ist.
    ''' </summary>
    ''' <returns>Anmeldestatus als Boolean</returns>
    ''' <remarks></remarks>
    Public Function IsLoggedIn() As Boolean
        Try
            Return oWMSession.aLoggedin
        Catch ex As Exception
            Logger.Error(ex)
        End Try

        Return False
    End Function

    ''' <summary>
    ''' Liefert den Servernamen an dem windream aktuell angemeldet ist.
    ''' </summary>
    ''' <returns>Servername als String</returns>
    ''' <remarks></remarks>
    Public Function GetCurrentServer() As String
        Try
            Logger.Debug(oBrowser.GetCurrentServer.ToString)
            Return oBrowser.GetCurrentServer 'ClassWindream.oBrowser.GetCurrentServer
        Catch ex As Exception
            Logger.Error(ex)
        End Try

        Return ""
    End Function

    'Public Function GetSharedCurrentServer() As String
    '    Try
    '        Return ClassWindream.oBrowser.GetCurrentServer
    '    Catch ex As Exception
    '        MsgBox("Der aktuell gewählte windream-Server konnte nicht ausgelesen werden." & vbNewLine & vbNewLine & "Fehlernachricht:" & vbNewLine & ex.Message, MsgBoxStyle.Critical, "Fehler beim Auslesen des windream-Servers")
    '    End Try

    '    Return ""
    'End Function


    'Liefert das Windream-Laufwerk des windream-Servers, in Form '[Laufwerksbuchstabe]:'. (z.B. 'W:')
    'Laufwerksbuchstabe mit Doppelpunkt als String</returns>
    '
    'Public Function GetWindreamDriveLetter() As String

    '    Try
    '        Dim oControl As AISCONTROLDATACOMLib.AISControlData
    '        Dim sDrive As String = ""

    '        '        oControl = New AISCONTROLDATACOMLib.AISControlData

    '        '        sDrive = oControl.GetStringValue(&H10040003)

    '        '        Return sDrive & ":"

    '    Catch ex As Exception
    '        MsgBox("Fehlernachricht: " & ex.Message, MsgBoxStyle.Critical, "Fehler beim Auslesen des windream-Laufwerks")
    '    End Try

    '    Return ""
    'End Function

    ''' <summary>
    ''' Liefert den Typen eines Indexes als Integer.
    ''' </summary>
    ''' <param name="indexname">Name des zu überprüfenden Indexfeldes</param>
    ''' <returns>Liefert eine Zahl, die einen Typen beschreibt</returns>
    ''' <remarks></remarks>
    Public Function GetTypeOfIndexAsIntByName(ByVal indexname As String) As Integer
        Try
            Dim oAttribute = oWMSession.GetWMObjectByName(WINDREAMLib.WMEntity.WMEntityAttribute, indexname)
            Dim vType = oAttribute.getVariableValue("dwAttrType")
            Return vType
        Catch ex As Exception
            Return Nothing
        End Try
    End Function
    Public Function GetValuesfromAuswahlliste(ByVal indexname As String) As Object
        Try
            'Dim oAttribute = oSession.GetWMObjectByName(WINDREAMLib.WMEntity.WMEntityAttribute, indexname)
            'Dim vType = oAttribute.getVariableValue("vItems")
            'Return vType
            Dim oChoiceList = oWMSession.GetWMObjectByName(WMEntityChoiceList, indexname)
            If Err.Number = 0 And TypeName(oChoiceList) <> "Nothing" Then
                Dim Values = oChoiceList
                Values = oChoiceList.GetVariableValue("vItems")
                Dim anz As Integer = 0

                For Each CLItem In Values
                    If oChoiceList.aName IsNot Nothing Then
                        anz += 1
                    End If
                Next
                Dim strListe(anz - 1)
                Dim zahl As Integer = 0
                For Each CLItem In Values
                    If oChoiceList.aName IsNot Nothing Then
                        strListe(zahl) = CLItem
                        zahl += 1
                    End If
                Next
                Return strListe
            Else
                Logger.Warn("Auswahlliste: " & indexname & " nicht gefunden.")
                Return Nothing
            End If

        Catch ex As Exception
            Logger.Error(ex)
            Return Nothing
        End Try
    End Function
    Public Function WDObject_exists(wdobj_location As String)
        Dim WDObject As WMObject
        Try
            WDObject = oWMSession.GetWMObjectByPath(WINDREAMLib.WMEntity.WMEntityDocument, wdobj_location.Substring(2))
            If WDObject Is Nothing Then
                Return False
            Else
                Logger.Debug("WDObject exists")
                Return True

            End If
        Catch ex As Exception
            ' bei einem Fehler einen Eintrag in der Logdatei machen
            Logger.Error(ex)
            Return False
        End Try
    End Function
    Public Function GetSearchDocuments(ByVal wdfLocation As String)
        Try
            Dim SearchName = wdfLocation.Substring(wdfLocation.LastIndexOf("\") + 1)
            Dim SearchPath = wdfLocation.Substring(0, wdfLocation.Length - SearchName.Length)
            Logger.Info("WMSearch: " & wdfLocation.ToLower)
            If System.IO.File.Exists(wdfLocation.ToLower) Then
                Logger.Debug("Search exists")
            End If
            oController.CheckSearchProfile(wdfLocation.ToLower) 'wdfLocation.ToLower)
            Logger.Debug("oController erzeugt")
            Dim suchTyp = oController.SearchProfileTargetProgID
            Dim ExSettings As Object
            Dim oSearch As Object
            ExSettings = oController.SearchProfileExSettings
            If ExSettings = 0 Then ExSettings = 7

            Dim srchQuick As WMOSRCHLib.WMQuickSearch = CreateObject("WMOSrch.WMQuickSearch")
            Dim srchIndex As WMOSRCHLib.WMIndexSearch = CreateObject("WMOSrch.WMIndexSearch")
            Dim srchObjectType As WMOSRCHLib.WMObjectTypeSearch = CreateObject("WMOSrch.WMObjectTypeSearch")
            Logger.Debug("WD Objekte in GetSearchDocuments erzeugt")
            Logger.Debug(suchTyp.ToString.ToUpper)
            ''  Der öffentliche Member CheckSearchProfile für den Typ IWMQuickSearch7 wurde nicht gefunden. [Microsoft.VisualBasic] => GetSearchDocuments()
            Select Case suchTyp.ToString.ToUpper
                Case "WMOSRCH.WMQUICKSEARCH"
                    srchQuick.WMSession = CreateObject("Windream.WMSession", GetCurrentServer)
                    oConnect.LoginSession(srchQuick.WMSession)
                    srchQuick.ClearSearch()
                    srchQuick.SearchProfilePath = SearchPath
                    srchQuick.LoadSearchProfile(SearchName)
                    oSearch = srchQuick.GetSearch()

                Case "WMOSRCH.WMINDEXSEARCH"
                    srchIndex.WMSession = CreateObject("Windream.WMSession", GetCurrentServer)
                    Logger.Debug("Session created...")
                    oConnect.LoginSession(srchIndex.WMSession)
                    Logger.Debug("LoginSession...")
                    srchIndex.SearchProfilePath = SearchPath
                    Logger.Debug("SearchPath...")
                    srchIndex.LoadSearchProfile(SearchName)
                    Logger.Debug("LoadSearchProfile...")
                    oSearch = srchIndex.GetSearch()
                    Logger.Debug("GetSearch...")
                Case "WMOSRCH.WMOBJECTTYPESEARCH"
                    srchObjectType.WMSession = CreateObject("Windream.WMSession", GetCurrentServer)
                    oConnect.LoginSession(srchObjectType.WMSession)
                    srchObjectType.ClearSearch()
                    srchObjectType.SearchProfilePath = SearchPath
                    srchObjectType.LoadSearchProfile(SearchName)
                    oSearch = srchObjectType.GetSearch()

                Case Else
                    Logger.Warn("KEIN GÜLTIGER WINDREAM-SUCHTYP")

                    Return Nothing
            End Select
            Dim WMObjects As Object
            WMObjects = oSearch.Execute
            Logger.Debug("WD Objekte werden zurückgegeben")
            Return oSearch.execute

        Catch ex As Exception
            ' bei einem Fehler einen Eintrag in der Logdatei machen
            Logger.Error(ex)
            Return Nothing
        End Try

    End Function

#End Region

End Class

